#include "stdafx.h"
#include "ArchiverB2E.h"
#include "../Utilities/FileOperation.h"
#include "../resource.h"
#include "../ConfigCode/ConfigExtract.h"
#include "../ConfigCode/ConfigB2E.h"

CArchiverB2E::CArchiverB2E():
	B2ESetScriptDirectory(NULL),
	B2EScriptGetCount(NULL),
	B2EScriptGetAbility(NULL),
	B2EScriptGetCompressType(NULL),
	B2EScriptGetCompressMethod(NULL),
	B2EScriptGetDefaultCompressMethod(NULL),
	B2EScriptGetExtractorIndex(NULL)
{
//	TRACE(_T("CArchiverB2E()\n"));
	m_nRequiredVersion=5;
	m_strDllName=_T("B2E32.DLL");
	m_AstrPrefix="B2E";
}

CArchiverB2E::~CArchiverB2E()
{
//	TRACE(_T("~CArchiverB2E()\n"));
	FreeDLL();
}

LOAD_RESULT CArchiverB2E::LoadDLL(CConfigManager &ConfMan,CString &strErr)
{
	FreeDLL();

	//NX̃\bhĂ
	LOAD_RESULT res=CArchiverDLL::LoadDLL(ConfMan,strErr);
	if(LOAD_RESULT_OK!=res){
		return res;
	}

	//ƎAPIQ
	B2ESetScriptDirectory=(B2ESETSCRIPTDIRECTORY)GetProcAddress(m_hInstDLL,"B2ESetScriptDirectory");
	if(NULL==B2ESetScriptDirectory){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2ESetScriptDirectory"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetCount=(B2ESCRIPTGETCOUNT)GetProcAddress(m_hInstDLL,"B2EScriptGetCount");
	if(NULL==B2EScriptGetCount){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2EScriptGetCount"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetAbility=(B2ESCRIPTGETABILITY)GetProcAddress(m_hInstDLL,"B2EScriptGetAbility");
	if(NULL==B2EScriptGetAbility){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2EScriptGetAbility"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetCompressType=(B2ESCRIPTGETCOMPRESSTYPE)GetProcAddress(m_hInstDLL,"B2EScriptGetCompressType");
	if(NULL==B2EScriptGetCompressType){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2EScriptGetCompressType"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetCompressMethod=(B2ESCRIPTGETCOMPRESSMETHOD)GetProcAddress(m_hInstDLL,"B2EScriptGetCompressMethod");
	if(NULL==B2EScriptGetCompressMethod){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2EScriptGetCompressMethod"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetDefaultCompressMethod=(B2ESCRIPTGETDEFAULTCOMPRESSMETHOD)GetProcAddress(m_hInstDLL,"B2EScriptGetDefaultCompressMethod");
	if(NULL==B2EScriptGetDefaultCompressMethod){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2EScriptGetDefaultCompressMethod"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetExtractorIndex=(B2ESCRIPTGETEXTRACTORINDEX)GetProcAddress(m_hInstDLL,"B2EScriptGetExtractorIndex");
	if(NULL==B2EScriptGetExtractorIndex){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,_T("B2EScriptGetExtractorIndex"));
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	// [h
	//===================
	// ݒ
	CConfigB2E Config;
	Config.load(ConfMan);
	if(_tcslen(Config.ScriptDirectory)>0 && PathIsDirectory(Config.ScriptDirectory)){
		B2ESetScriptDirectory(CT2A(Config.ScriptDirectory));
	}

	return LOAD_RESULT_OK;
}

void CArchiverB2E::FreeDLL()
{
	if(m_hInstDLL){
		B2ESetScriptDirectory=NULL;
		B2EScriptGetCount=NULL;
		B2EScriptGetAbility=NULL;
		B2EScriptGetCompressType=NULL;
		B2EScriptGetCompressMethod=NULL;
		B2EScriptGetDefaultCompressMethod=NULL;
		B2EScriptGetExtractorIndex=NULL;
		CArchiverDLL::FreeDLL();
	}
}

bool CArchiverB2E::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &ConfigManager,const PARAMETER_TYPE,int Options,LPCTSTR lpszFormat,LPCTSTR lpszMethod,LPCTSTR,CString &strLog)
{
	return B2ECompress(ArcFileName,ParamList,ConfigManager,lpszFormat,lpszMethod,(Options & COMPRESS_SFX) !=0 ,strLog);
}

bool CArchiverB2E::B2ECompress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &ConfigManager,LPCTSTR lpszFormat,LPCTSTR lpszMethod,bool bSFX,CString &strLog)
{
	if(!IsOK()||!lpszFormat){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE(_T("ArcFileName=%s\n"),ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("b2e"))){
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile){
			strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS));
			return false;
		}

		TRACE(_T("X|Xt@Cւ̏\n"));
		//kt@C
		/*
		 * B2Ep̏o̓t@Cɂ́Agq.archivet̂w肳B
		 * ́Ãt@Cč폜Ȃ悤ɂ邽߂ł
		 * ŉ߂ė]vȊgq폜
		 */
		CPath tmpName=ArcFileName;
		tmpName.RemoveExtension();
		WriteResponceFile(hFile,tmpName);

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//---kp[^
	//k`
	Param =_T("\"-c");
	Param+=lpszFormat;
	Param+=_T("\" ");

	//k\bh
	if(lpszMethod&&_tcslen(lpszMethod)>0){
		Param+=_T("\"-m");
		Param+=lpszMethod;
		Param+=_T("\" ");
	}

	//ȉ
	if(bSFX){
		Param+=_T("-s ");
	}

	//X|Xt@Cw
	Param+=_T("\"-@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));

	//---s
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

bool CArchiverB2E::Extract(LPCTSTR ArcFileName,CConfigManager&,const CConfigExtract &Config,bool bSafeArchive,LPCTSTR OutputDir,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	if(!bSafeArchive){
		//sȃpX΁As邩ǂmF
		//ApX`FbNs\ȂƂɂ͂̌xoȂB
		CString msg;
		msg.Format(IDS_ASK_CONTINUE_EXTRACT,ArcFileName);
		if(IDYES!=MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2)){
			return false;
		}
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T("-e ");	//
	//㏑ɂ͖Ή

	//o͐w
	Param+=_T("\"-o");
	Param+=OutputDir;
	Param+=_T("\" ");

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];


	return 0==Ret;
}


//=========================================================
// B2EGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverB2E::ExamineArchive(LPCTSTR ArcFileName,CConfigManager& ConfMan,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir,CString &strErr)
{
	if(!IsOK()){
		return false;
	}
/*	UINT uIndex=B2EScriptGetExtractorIndex(ArcFileName);
	if(uIndex==0xFFFFFFFF)return false;	//Ή`G[

	WORD wAbility;
	if(!B2EScriptGetAbility(uIndex,&wAbility))return false;
	if(!(wAbility&B2EABILITY_LIST))return false;	//łȂ*/

	//------
	//łȂƂɂ́AExamineArchive̎|񍐂Ă̂łKv͂Ȃ

	return _ExamineArchive(ArcFileName,ConfMan,bInFolder,bSafeArchive,0,BaseDir,strErr);
}

bool CArchiverB2E::ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString> &FileList,CString &strLog,bool bUsePath)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("b2e"))){
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile){
			strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T("-e ");			//
	if(!bUsePath)Param+=_T("-g ");		//pX𖳌

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"-o");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"-@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE(_T("ArchiveHandlerĂяo\nCommandline Parameter:%s\n"),Param);
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<char> szLog(LOG_BUFFER_SIZE);
	szLog[0]='\0';
	int Ret=ArchiveHandler(NULL,CT2A(Param),&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

bool CArchiverB2E::QueryExtractSpecifiedOnlySupported(LPCTSTR ArcFileName)const
{
	UINT uIndex=B2EScriptGetExtractorIndex(CT2A(ArcFileName));
	if(uIndex==0xFFFFFFFF)return false;	//Ή`G[

	WORD wAbility;
	if(!B2EScriptGetAbility(uIndex,&wAbility))return false;
	if(wAbility&B2EABILITY_MELT_EACH)return true;	//ʉ𓀂łȂ
	return false;
}

bool CArchiverB2E::EnumCompressB2EScript(std::vector<B2ESCRIPTINFO> &ScriptInfoArray)
{
	ScriptInfoArray.clear();

	//XNvg̐擾
	const UINT uScriptCount=B2EScriptGetCount();

	if(uScriptCount==-1)return false;	//G[

	for(UINT uIndex=0;uIndex<uScriptCount;uIndex++){
		B2ESCRIPTINFO Info;
		Info.uIndex=uIndex;

		//\͂擾
		B2EScriptGetAbility(uIndex,&Info.wAbility);

		if(Info.wAbility&B2EABILITY_COMPRESS){	//---k\͂
			//k`擾
			B2EScriptGetCompressType(uIndex,Info.szFormat,_MAX_PATH);
			//k\bh擾
			{
				int i=0;
				char szBuffer[_MAX_PATH+1]={0};
				while(B2EScriptGetCompressMethod(uIndex,i,szBuffer,_MAX_PATH)){
					Info.MethodArray.push_back(szBuffer);
					i++;
				}
			}

			//ftHgk\bhԍ擾
			Info.nDefaultMethod=B2EScriptGetDefaultCompressMethod(uIndex);
			//---ǉ
			ScriptInfoArray.push_back(Info);
		}
	}
	return true;
}
