#pragma once
#include "arc_interface.h"


typedef BOOL (WINAPI *B2ESETSCRIPTDIRECTORY)(LPCSTR);	//B2ESetScriptDirectory
typedef int  (WINAPI *B2ESCRIPTGETCOUNT)();				//B2EScriptGetCount
typedef BOOL (WINAPI *B2ESCRIPTGETABILITY)(const UINT,LPWORD);	//B2EScriptGetAbility
typedef BOOL (WINAPI *B2ESCRIPTGETCOMPRESSTYPE)(const UINT,LPSTR,const DWORD);	//B2EScriptGetCompressType
typedef BOOL (WINAPI *B2ESCRIPTGETCOMPRESSMETHOD)(const UINT,const UINT,LPSTR,const DWORD);	//B2EScriptGetCompressMethod
typedef int  (WINAPI *B2ESCRIPTGETDEFAULTCOMPRESSMETHOD)(const UINT);	//B2EScriptGetDefaultCompressMethod
typedef UINT (WINAPI *B2ESCRIPTGETEXTRACTORINDEX)(LPCSTR);	//B2EScriptGetExtractorIndex

#define B2EABILITY_CHECK       1       //CheckArchive()̏\
#define B2EABILITY_MELT        2       //𓀏\
#define B2EABILITY_LIST        4       //ɓt@C̗񋓂\
#define B2EABILITY_MELT_EACH   8       //w肵t@Ĉ݂̉𓀂\
#define B2EABILITY_COMPRESS    16      //k\
#define B2EABILITY_ARCHIVE     32      //t@C܂Ƃ߂邱Ƃ\(cf.GZip)
#define B2EABILITY_SFX         64      //ȉ𓀃t@C쐬\

//B2EXNvg̏
struct B2ESCRIPTINFO{
	virtual ~B2ESCRIPTINFO(){}
	UINT uIndex;
	WORD wAbility;
	char szFormat[_MAX_PATH+1];	//k`
	std::vector<CStringA> MethodArray;
	int nDefaultMethod;
};

class CArchiverB2E:public CArchiverDLL{
protected:
	B2ESETSCRIPTDIRECTORY				B2ESetScriptDirectory;
	B2ESCRIPTGETCOUNT					B2EScriptGetCount;
	B2ESCRIPTGETABILITY					B2EScriptGetAbility;
	B2ESCRIPTGETCOMPRESSTYPE			B2EScriptGetCompressType;
	B2ESCRIPTGETCOMPRESSMETHOD			B2EScriptGetCompressMethod;
	B2ESCRIPTGETDEFAULTCOMPRESSMETHOD	B2EScriptGetDefaultCompressMethod;
	B2ESCRIPTGETEXTRACTORINDEX			B2EScriptGetExtractorIndex;
protected:
	//---internal functions
	bool B2ECompress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager&,LPCTSTR lpszFormat,LPCTSTR lpszMethod,bool bSFX,CString &);
public:
	CArchiverB2E();
	virtual ~CArchiverB2E();
	virtual LOAD_RESULT LoadDLL(CConfigManager&,CString &strErr)override;
	virtual void FreeDLL()override;
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR lpszFormat,LPCTSTR lpszMethod,LPCTSTR,CString &)override;
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &)override;
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false)override;
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool,bool&,bool&,CString&,CString &strErr)override;
	virtual bool IsWeakErrorCheck()const override{return true;}	//%Prefix%()̃G[`FbNÂ(XacRett̂悤)Ȃtrue
//	virtual bool IsWeakCheckArchive()const{return true;}	𓀌IɒT邽
	virtual bool QueryExtractSpecifiedOnlySupported(LPCTSTR)const override;

	//---Ǝ
	bool EnumCompressB2EScript(std::vector<B2ESCRIPTINFO>&);
};

