#include "stdafx.h"
#include "ArchiverUNLHA.h"
#include "../Utilities/FileOperation.h"
#include "../resource.h"
#include "../ConfigCode/ConfigExtract.h"
#include "../ConfigCode/ConfigUNLHA.h"

CArchiverUNLHA::CArchiverUNLHA():
	ArchiveHandlerW(NULL),
	ArchiverCheckArchiveW(NULL),
	ArchiverGetFileNameW(NULL),
	ArchiverOpenArchiveW(NULL),
	ArchiverFindFirstW(NULL),
	ArchiverFindNextW(NULL),
	ArchiverGetFileCountW(NULL),
	ArchiverGetMethodW(NULL)
{
//	TRACE(_T("CArchiverUNLHA()\n"));
	m_dwInspectMode=0x00000002L;	//M_REGARDLESS_INIT_FILE:WXg̒l
	m_nRequiredVersion=262;
	m_nRequiredSubVersion=227;
	m_strDllName=_T("UNLHA32.DLL");
	m_AstrPrefix="Unlha";
	m_AstrFindParam="*.*";
}

CArchiverUNLHA::~CArchiverUNLHA()
{
//	TRACE(_T("~CArchiverUNLHA()\n"));
	FreeDLL();
}

void CArchiverUNLHA::FormatCompressCommand(const CConfigLZH& Config,LPCTSTR lpszMethod,CString &Param)
{
	int nType=Config.CompressType;

	if(lpszMethod && *lpszMethod!=_T('\0')){
			 if(0==_tcsicmp(lpszMethod,_T("lh0")))nType=LZH_COMPRESS_LH0;
		else if(0==_tcsicmp(lpszMethod,_T("lh1")))nType=LZH_COMPRESS_LH1;
		else if(0==_tcsicmp(lpszMethod,_T("lh5")))nType=LZH_COMPRESS_LH5;
		else if(0==_tcsicmp(lpszMethod,_T("lh6")))nType=LZH_COMPRESS_LH6;
		else if(0==_tcsicmp(lpszMethod,_T("lh7")))nType=LZH_COMPRESS_LH7;
	}

	switch(nType){
	case LZH_COMPRESS_LH5:
		Param+=_T("-jm2 ");
		break;
	case LZH_COMPRESS_LH0:
		Param+=_T("-jm0 ");
		break;
	case LZH_COMPRESS_LH1:
		Param+=_T("-jm1 ");
		break;
	case LZH_COMPRESS_LH6:
		Param+=_T("-jm3 ");
		break;
	case LZH_COMPRESS_LH7:
		Param+=_T("-jm4 ");
		break;
	}
}

bool CArchiverUNLHA::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &ConfMan,const PARAMETER_TYPE,int Options,LPCTSTR,LPCTSTR lpszMethod,LPCTSTR,CString &strLog)
{
	if(!IsOK()){
		return false;
	}
	bool bSFX=(0!=(Options&COMPRESS_SFX));	//ȉ𓀍쐬Ȃtrue

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE(_T("ArcFileName=%s\n"),ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh"))){
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS));
			return false;
		}

		TRACE(_T("X|Xt@Cւ̏\n"));
		//kt@C
		WriteResponceFile(hFile,ArcFileName);

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();++ite){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=
		_T("a ")		//k
		_T("-d1 ")		//tH_ƁESt@CΏ
		_T("-+1 ")		//UNLHA32.DLL̃WXg̐ݒ𖳎
		_T("-jf0 ")		//[gL폜
		_T("-jso1 ")	//SH_DENYNO ł̃I[vsȂ
		_T("-jsm1 ")	//TEhg
	;

	CConfigLZH Config;
	Config.load(ConfMan);
	FormatCompressCommand(Config,lpszMethod,Param);
	if(bSFX){
		//ȉ𓀍쐬
		if(Config.ConfigSFX){
			Param+=_T("-gw3 ");	//ݒtWinSFX32M
		}
		else{
			Param+=_T("-gw4 ");	//ݒȂWinSFX32M
		}
	}

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<WCHAR> szLog(LOG_BUFFER_SIZE);
	szLog[0]=L'\0';
	int Ret=ArchiveHandlerW(NULL,Param,&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

//bSafeArchive͖
bool CArchiverUNLHA::Extract(LPCTSTR ArcFileName,CConfigManager&,const CConfigExtract &Config,bool,LPCTSTR OutputDir,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=
		_T("e ")			//
		_T("-x1 ")			//pXL
		_T("-jyc ")			//tH_쐬̊mFLZ
		_T("-a1 ")			//t@C̑WJ
		_T("-c1 ")			//^CX^vs
		_T("-+1 ")			//UNLHA32.DLL̃WXg̐ݒ𖳎
		_T("-jf0 ")			//[gL폜
		_T("-jso1 ")		//SH_DENYNO ł̃I[vsȂ
		_T("-jsm1 ")		//TEhg
		_T("-jsp23 ")		//sȃpX/䕶
		_T("-jsc ")			//WJłȂt@C̐Ԃ
	;
	if(Config.ForceOverwrite){
		//㏑
		Param+=_T("-jyo ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<WCHAR> szLog(LOG_BUFFER_SIZE);
	szLog[0]=L'\0';
	int Ret=ArchiveHandlerW(NULL,Param,&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	return 0==Ret;
}

//X|Xt@CɃt@CGXP[vsŏށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverUNLHA::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	CPath strBuffer;

	//t@C̐擪'-'Ȃ-gb(t@C)Ƃ
#if defined(_UNICODE)||defined(UNICODE)
	if(_T('-')==fname[0]){
#else
#error("not implemented or tested")
	if(_MBC_SINGLE==_mbsbtype((const unsigned char*)fname,0)&&_T('-')==fname[0]){
#endif//defined(_UNICODE)||defined(UNICODE)
		strBuffer=_T("-gb");
		strBuffer+=fname;
	}
	else{
		strBuffer=fname;
	}
	strBuffer.QuoteSpaces();

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,(LPCBYTE)(LPCTSTR)strBuffer,_tcslen(strBuffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,(DWORD)_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
/*	char CRLF[]="\r\n";
	WriteFile(hFile,&CRLF,strlen(CRLF)*sizeof(char),&dwWritten,NULL);*/
}


//=========================================================
// UnlhaGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverUNLHA::ExamineArchive(LPCTSTR ArcFileName,CConfigManager& ConfMan,bool bSkipDir,bool &bInFolder,bool &,CString &BaseDir,CString &strErr)
{
	//"-jsp" XCb`gC Unicode 䕶sƂĈ悤ɂB
	if(bSkipDir){
		TRACE(_T("dtH_\n"));
		return true;
	}
	return _ExamineArchiveFast(ArcFileName,ConfMan,bInFolder,BaseDir,strErr);
}

bool CArchiverUNLHA::ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString> &FileList,CString &strLog,bool bUsePath)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh"))){
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile){
			strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;++ite){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=
		_T("e ")			//
		_T("-p1 ")			//SpXōv
		_T("-jyc ")			//tH_쐬̊mFLZ
		_T("-a2 ")			//t@C̑WJ
		_T("-c1 ")			//^CX^vs
		_T("-+1 ")			//UNLHA32.DLL̃WXg̐ݒ𖳎
		_T("-jf0 ")			//[gL폜
		_T("-jso1 ")		//SH_DENYNO ł̃I[vsȂ
		_T("-jsm1 ")		//TEhg
		_T("-jsp23 ")		//sȃpX/䕶
		_T("-jsc ")			//WJłȂt@C̐Ԃ
	;
	if(bUsePath){
		Param+=_T("-x1 ");			//pXL
	}
	else{
		Param+=_T("-x0 ");			//pX𖳌
	}
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE(_T("ArchiveHandlerĂяo\nCommandline Parameter:%s\n"),Param);
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<WCHAR> szLog(LOG_BUFFER_SIZE);
	szLog[0]=L'\0';
	int Ret=ArchiveHandlerW(NULL,Param,&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

bool CArchiverUNLHA::DeleteItemFromArchive(LPCTSTR ArcFileName,CConfigManager&,const std::list<CString>& FileList,CString &strLog)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh"))){
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//폜Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS));
			return false;
		}

		std::list<CString>::const_iterator ite=FileList.begin();
		const std::list<CString>::const_iterator end=FileList.end();
		for(;ite!=end;++ite){
			CString tmp=*ite;
			//fBNg/菜
#if defined(_UNICODE)||defined(UNICODE)
			if(_T('/')==tmp[tmp.GetLength()-1]){
				tmp.Delete(tmp.GetLength()-1);
			}
#else
			if(_MBC_SINGLE==_mbsbtype((const unsigned char*)(LPCTSTR)*ite,(*ite).GetLength()-1)){
				if(_T('/')==tmp[tmp.GetLength()-1]){
					tmp.Delete(tmp.GetLength()-1);
				}
			}
#endif//defined(_UNICODE)||defined(UNICODE)
			WriteResponceFile(hFile,tmp);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//폜p[^
	Param+=
		_T("d ")			//폜
		_T("-r0 ")			//ċA[h(ftHg)
		_T("-p1 ")			//SpXōv
		_T("-+1 ")			//UNLHA32.DLL̃WXg̐ݒ𖳎
		_T("-jso1 ")		//SH_DENYNO ł̃I[vsȂ
		_T("-jsm1 ")		//TEhg
		_T("-d ")			//fBNg̊i[
	;
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE(_T("ArchiveHandlerĂяo\nCommandline Parameter:%s\n"),Param);
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<WCHAR> szLog(LOG_BUFFER_SIZE);
	szLog[0]=L'\0';
	int Ret=ArchiveHandlerW(NULL,Param,&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}

ARCRESULT CArchiverUNLHA::TestArchive(LPCTSTR ArcFileName,CString &strLog)
{
	TRACE(_T("TestArchive() called.\n"));
	ASSERT(IsOK());
	if(!IsOK()){
		return TEST_ERROR;
	}

	//tR}hɂeXgĂ
	CString Param=
		_T("t ")			//eXg
		_T("-+1 ")			//UNLHA32.DLL̃WXg̐ݒ𖳎
		_T("-jso1 ")		//SH_DENYNO ł̃I[vsȂ
		_T("-jsc ")			//WJłȂt@C̐Ԃ
//		_T("-jsp23 ")		//sȃpX/䕶->G[ƂȂȂ

		_T("\"")
	;
	Param+=ArcFileName;
	Param+=_T("\"");

	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<WCHAR> szLog(LOG_BUFFER_SIZE);
	szLog[0]=L'\0';
	int Ret=ArchiveHandlerW(NULL,Param,&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	if(Ret==0)return TEST_OK;
	else return TEST_NG;
}

BOOL CArchiverUNLHA::CheckArchive(LPCTSTR _szFileName)
{
	if(!ArchiverCheckArchiveW){
		ASSERT(ArchiverCheckArchiveW);
		return false;
	}
	return ArchiverCheckArchiveW(_szFileName,CHECKARCHIVE_BASIC);
}

int CArchiverUNLHA::GetFileCount(LPCTSTR _szFileName)
{
	if(!ArchiverGetFileCountW){
		return -1;
	}
	return ArchiverGetFileCountW(_szFileName);
}

void CArchiverUNLHA::FreeDLL()
{
	if(m_hInstDLL){
		ArchiveHandlerW				=NULL;
		ArchiverCheckArchiveW		=NULL;
		ArchiverGetFileCountW		=NULL;
		ArchiverGetFileNameW		=NULL;
		ArchiverOpenArchiveW		=NULL;
		ArchiverFindFirstW			=NULL;
		ArchiverFindNextW			=NULL;
		ArchiverGetMethodW			=NULL;
		CArchiverDLL::FreeDLL();
	}
}

LOAD_RESULT CArchiverUNLHA::LoadDLL(CConfigManager &ConfigManager,CString &strErr)
{
	FreeDLL();

	//NX̃\bhĂ
	LOAD_RESULT res=CArchiverDLL::LoadDLL(ConfigManager,strErr);
	if(LOAD_RESULT_OK!=res){
		return res;
	}
	//ANSIł͊ԈĎgƂ̂Ȃ悤ɃZbg
	ArchiveHandler				=NULL;
	ArchiverCheckArchive		=NULL;
	ArchiverGetFileCount		=NULL;
	ArchiverGetFileName			=NULL;
	ArchiverOpenArchive			=NULL;
	ArchiverFindFirst			=NULL;
	ArchiverFindNext			=NULL;
	ArchiverGetMethod			=NULL;

	ASSERT(ArchiverGetWriteTimeEx);
	if(!ArchiverGetWriteTimeEx){	//UNLHA32.DLLł͎Ă͂
		return LOAD_RESULT_INVALID;
	}

	//---UNICODEł[h;\̓`FbN͊ɍςł̂ōsȂ

	ArchiveHandlerW=(COMMON_ARCHIVER_HANDLERW)GetProcAddress(m_hInstDLL,m_AstrPrefix+"W");
	if(NULL==ArchiveHandlerW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,m_AstrPrefix+"W");
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	CStringA FunctionName=m_AstrPrefix;
	FunctionName+="CheckArchiveW";
	ArchiverCheckArchiveW=(COMMON_ARCHIVER_CHECKARCHIVEW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverCheckArchiveW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//XacRett.dllAish32.dllT|[gĂȂ
	FunctionName=m_AstrPrefix;
	FunctionName+="GetFileCountW";
	ArchiverGetFileCountW=(COMMON_ARCHIVER_GETFILECOUNTW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileCountW){
	//[hɎsĂG[Ƃ͂Ȃ
		TRACE(_T("Failed to Load Function %s\n"),FunctionName);
	}

	//------------
	// ǉ֐Q
	//------------
	FunctionName=m_AstrPrefix;
	FunctionName+="OpenArchiveW";
	ArchiverOpenArchiveW=(COMMON_ARCHIVER_OPENARCHIVEW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverOpenArchiveW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//FindFirst
	FunctionName=m_AstrPrefix;
	FunctionName+="FindFirstW";
	ArchiverFindFirstW=(COMMON_ARCHIVER_FINDFIRSTW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverFindFirstW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//FindNext
	FunctionName=m_AstrPrefix;
	FunctionName+="FindNextW";
	ArchiverFindNextW=(COMMON_ARCHIVER_FINDNEXTW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverFindNextW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//t@C擾
	FunctionName=m_AstrPrefix;
	FunctionName+="GetFileNameW";
	ArchiverGetFileNameW=(COMMON_ARCHIVER_GETFILENAMEW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileNameW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//t@Ck\bh擾
	FunctionName=m_AstrPrefix;
	FunctionName+="GetMethodW";
	ArchiverGetMethodW=(COMMON_ARCHIVER_GETMETHODW)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetMethodW){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,FunctionName);
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}


	TRACE(_T("Standard Function Set Load\n"));
	return LOAD_RESULT_OK;
}

bool CArchiverUNLHA::InspectArchiveBegin(LPCTSTR ArcFileName,CConfigManager&)
{
	TRACE(_T("CArchiverUNLHA::InspectArchiveBegin()\n"));
	ASSERT(ArchiverOpenArchiveW);
	if(!ArchiverOpenArchiveW){
		return false;
	}
	if(m_hInspectArchive){
		ASSERT(!"Close the Archive First!!!\n");
		return false;
	}
	m_hInspectArchive=ArchiverOpenArchiveW(NULL,ArcFileName,m_dwInspectMode);
	if(!m_hInspectArchive){
		TRACE(_T("Failed to Open Archive\n"));
		return false;
	}
	m_bInspectFirstTime=true;

	FILL_ZERO(m_IndividualInfoW);
	return true;
}

bool CArchiverUNLHA::InspectArchiveGetFileName(CString &FileName)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	if(ArchiverGetFileNameW){
		std::vector<WCHAR> szBuffer(FNAME_MAX32*2+1);
		ArchiverGetFileNameW(m_hInspectArchive,&szBuffer[0],FNAME_MAX32*2);
		FileName=&szBuffer[0];
		return true;
	}else{
		return false;
	}
}


bool CArchiverUNLHA::InspectArchiveNext()
{
	ASSERT(ArchiverFindFirstW);
	ASSERT(ArchiverFindNextW);
	if(!ArchiverFindFirstW||!ArchiverFindNextW){
		return false;
	}
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}

	FILL_ZERO(m_IndividualInfoW);
	bool bRet;
	if(m_bInspectFirstTime){
		m_bInspectFirstTime=false;
		bRet=(0==ArchiverFindFirstW(m_hInspectArchive,CStringW(m_AstrFindParam),&m_IndividualInfoW));
	}
	else{
		bRet=(0==ArchiverFindNextW(m_hInspectArchive,&m_IndividualInfoW));
	}

	return bRet;
}

//ɓt@CCRC擾
DWORD CArchiverUNLHA::InspectArchiveGetCRC()
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}
	return m_IndividualInfoW.dwCRC;
}

//ɓt@Ck擾
WORD CArchiverUNLHA::InspectArchiveGetRatio()
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}

	return m_IndividualInfoW.wRatio;
}

//ɓt@Ci[[h擾
bool CArchiverUNLHA::InspectArchiveGetMethodString(CString &strMethod)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}

	ASSERT(ArchiverGetMethodW);


	//\0ŏIĂ邩ǂۏ؂łȂ
	WCHAR szBuffer[32]={0};

	if(ArchiverGetMethodW){
		if(0!=ArchiverGetMethodW(m_hInspectArchive,szBuffer,31)){
			//\̂擾
			wcsncpy_s(szBuffer,m_IndividualInfoW.szMode,8);
		}
	}
	else return false;

	//i[
	strMethod=szBuffer;
	return true;
}

bool CArchiverUNLHA::AddItemToArchive(LPCTSTR ArcFileName,const std::list<CString> &FileList,CConfigManager &ConfMan,LPCTSTR lpDestDir,CString &strLog)
{
	//---JgfBNgݒ̂߂\ŏI_pX擾
	CString strBasePath;
	UtilGetBaseDirectory(strBasePath,FileList);
	TRACE(_T("%s\n"),strBasePath);

	//JgfBNgݒ
	SetCurrentDirectory(strBasePath);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh"))){
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_CREATE));
		return false;
	}
	ASSERT(0!=_tcslen(ResponceFileName));

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			strLog=CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS));
			return false;
		}

		TRACE(_T("X|Xt@Cւ̏\n"));
		//kt@C
		WriteResponceFile(hFile,ArcFileName);

		const int BasePathLength=strBasePath.GetLength();
		std::list<CString>::const_iterator ite;
		for(ite=FileList.begin();ite!=FileList.end();++ite){
			//x[XpXɑ΃pX擾 : ʂłpX̕Jbg
			LPCTSTR lpszPath=(LPCTSTR)(*ite)+BasePathLength;

			if(*lpszPath==_T('\0')){
				//BasePathƓɂȂċɂȂĂ܂pX΁AJgfBNgwɓĂ
				WriteResponceFile(hFile,_T("."));
			}
			else{
				WriteResponceFile(hFile,lpszPath);
			}
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE(_T("DLLɓnIvV̐ݒ\n"));

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=
		_T("a ")		//k
		_T("-d1 ")		//tH_ƁESt@CΏ
		_T("-+1 ")		//UNLHA32.DLL̃WXg̐ݒ𖳎
		_T("-jf0 ")		//[gL폜
		_T("-jso1 ")	//SH_DENYNO ł̃I[vsȂ
		_T("-jsm1 ")	//TEhg
	;
	CConfigLZH Config;
	Config.load(ConfMan);
	FormatCompressCommand(Config,NULL,Param);

	//o͐tH_̖̃obNXbV폜
	CPath destPath(lpDestDir);
	destPath.RemoveBackslash();
	//ǉk
	Param+=_T("-jb\"");
	Param+=(CString)destPath;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE(_T("ArchiveHandler Commandline Parameter:%s\n"),Param);

	TRACE(_T("ArchiveHandlerĂяo\n"));
	//char szLog[LOG_BUFFER_SIZE]={0};
	std::vector<WCHAR> szLog(LOG_BUFFER_SIZE);
	szLog[0]=L'\0';
	int Ret=ArchiveHandlerW(NULL,Param,&szLog[0],LOG_BUFFER_SIZE-1);
	strLog=&szLog[0];

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	return 0==Ret;
}
