#include "stdafx.h"
#include "arc_interface.h"
#include "../Utilities/FileOperation.h"

CArchiverDLL::CArchiverDLL():
	m_hInspectArchive(NULL),
	m_bInspectFirstTime(false),
	m_dwInspectMode(0),
	m_nRequiredVersion(0),
	m_nRequiredSubVersion(0),
	m_LoadLevel(LOAD_DLL_STANDARD),
	m_AstrFindParam("*"),
	m_hInstDLL(NULL),
	ArchiveHandler(NULL),
	ArchiverGetVersion(NULL),
	ArchiverGetSubVersion(NULL),
	ArchiverCheckArchive(NULL),
	ArchiverGetFileCount(NULL),
	ArchiverQueryFunctionList(NULL),
	ArchiverGetFileName(NULL),
	ArchiverOpenArchive(NULL),
	ArchiverCloseArchive(NULL),
	ArchiverFindFirst(NULL),
	ArchiverFindNext(NULL),
	ArchiverGetAttribute(NULL),
	ArchiverGetOriginalSizeEx(NULL),
	ArchiverGetCompressedSizeEx(NULL),
	ArchiverGetWriteTime(NULL),
	ArchiverGetWriteTimeEx(NULL),
	ArchiverGetMethod(NULL)
{
}

WORD CArchiverDLL::GetVersion()const
{
	if(!ArchiverGetVersion){
		ASSERT(ArchiverGetVersion);
		return 0;
	}
	return ArchiverGetVersion();
}

WORD CArchiverDLL::GetSubVersion()const
{
	if(!ArchiverGetSubVersion){
//		ASSERT(ArchiverGetSubVersion);
		return 0;
	}
	return ArchiverGetSubVersion();
}

bool CArchiverDLL::GetVersionString(CString &String)const
{
	if(!m_hInstDLL||!ArchiverGetVersion){
		String.LoadString(IDS_MESSAGE_DLL_NOT_AVAILABLE);
		return false;
	}
	if(!ArchiverGetSubVersion){
		//used sprintf
		String.Format(_T("Ver.%.2f"),ArchiverGetVersion()/100.0f);
	}
	else{
		String.Format(_T("Ver.%.2f.%.2f"),ArchiverGetVersion()/100.0f,ArchiverGetSubVersion()/100.0f);
	}
	return true;
}

BOOL CArchiverDLL::CheckArchive(LPCTSTR _szFileName)
{
	if(!ArchiverCheckArchive){
		ASSERT(ArchiverCheckArchive);
		return false;
	}
	return ArchiverCheckArchive(CT2A(_szFileName),CHECKARCHIVE_BASIC);
}

int CArchiverDLL::GetFileCount(LPCTSTR _szFileName)
{
	if(!ArchiverGetFileCount){
		return -1;
	}
	return ArchiverGetFileCount(CT2A(_szFileName));
}

bool CArchiverDLL::_ExamineArchive(LPCTSTR ArcFileName,CConfigManager& ConfMan,bool &bInFolder,bool &bSafeArchive,const int MaxRepeat,CString &BaseDir,CString &strErr)
{
	ASSERT(IsOK());
	if(!IsOK()){
		return false;
	}

	if(!InspectArchiveBegin(ArcFileName,ConfMan)){
		strErr.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		return false;
	}

	bInFolder=true;
	bool bSureDir=false;	//BaseDirɓĂ镶񂪊mɃtH_łȂtrue
	TRACE(_T("========\n"));

	while(InspectArchiveNext()){
		CString Buffer;
		InspectArchiveGetFileName(Buffer);
		Buffer.Replace(_T('\\'),_T('/'));		//pX؂蕶̒u
		TRACE(_T("%s\n"),Buffer);

		/*
		Separator('/' or '\')͊i[t@C̐擪ɂ܂܂ĂĂׂł̂ŁA
		i[t@C̐擪ɂSeparatorĂtH_Ɋi[ꂽԂƂ͌ȂȂB
		SeparatorMaxRepeat葽ƕsƂ
		AMaxRepeat-1̂Ƃ̓G[Ƃ͂Ȃ
		*/
		const int Length=Buffer.GetLength();
		int StartIndex=0;
		for(;StartIndex<Length;StartIndex++){
			//擪'/'Ƃ΂Ă
#if defined(_UNICODE)||defined(UNICODE)
			if(_T('/')!=Buffer[StartIndex])break;
#else
			if(_MBC_SINGLE==_mbsbtype((const unsigned char *)(LPCTSTR)Buffer,StartIndex)){
				if(_T('/')!=Buffer[StartIndex])break;
			}
			else{	//SpȂ'/'ł͂Ȃ
				break;
			}
#endif//defined(_UNICODE)||defined(UNICODE)
			if(-1!=MaxRepeat){
				if(StartIndex>=MaxRepeat){	//'/'MaxRepeatȏ㑱ꍇ
					//댯ȃt@Cƕ̂ŊčI
					InspectArchiveEnd();
					bSafeArchive=false;
					bInFolder=false;
					return true;
				}
			}
		}
		if((-1!=Buffer.Find(_T("../"),StartIndex))||	//΃pXw肪΁A͈Sȃt@Cł͂Ȃ
			(-1!=Buffer.Find(_T(':'),StartIndex))){	//hCu΁A͈Sȃt@Cł͂Ȃ
			//댯ȃt@Cƕ̂ŊčI
			InspectArchiveEnd();
			bSafeArchive=false;
			bInFolder=false;
			return true;
		}

		//͓dfBNg
		//łɓdfBNg肪tĂꍇ͈Ŝ݂ɓO

		int FoundIndex=0;
		while(bInFolder){
			FoundIndex=Buffer.Find(_T('/'),StartIndex);
			if(-1==FoundIndex){	//'/'i[t@C̐擪ȊOɊ܂܂Ȃꍇ
				if(!BaseDir.IsEmpty()&&BaseDir==Buffer){
					bSureDir=true;	//BaseDirtH_łƊmFꂽ
					break;
				}
				else if(BaseDir.IsEmpty()){
					//tH_̌'/'tȂA[JCo
					//̂ŏɏoĂƂ́AtH_Ɖ肷
					BaseDir=Buffer;
					bSureDir=false;
					break;
				}
			//	else{	͌Â@
			//		bInFolder=false;
			//		break;
			//	}
			}
			CString Dir=Buffer.Mid(StartIndex,FoundIndex-StartIndex);	//SeparatoȓO܂ł̕(fBNgɑ)𔲂oĂ
			//܂łׂ̒DirEmptył͂ȂƂۏ؂Ă
			//܂A댯ł͂ȂƂĂ
			TRACE(_T("Base=%s,Dir=%s\n"),BaseDir,Dir);

			if(_T('.')==Dir){	//./΃fBNgwƂĂ͖
				StartIndex=FoundIndex+1;
				continue;
			}
			if(BaseDir.IsEmpty()){
				BaseDir=Dir;
				bSureDir=true;
			}
			else if(BaseDir!=Dir){
				bInFolder=false;
			}
			else bSureDir=true;	//BaseDirfBNgƊmFꂽ
			break;
		}
	}
	TRACE(_T("========\n"));

	InspectArchiveEnd();
	bSafeArchive=true;

	//tH_ɓĂ悤ł͂邪AfBNgƉ肳ꂽ̏ꍇ
	if(bInFolder&&!bSureDir)bInFolder=false;
	return true;
}

bool CArchiverDLL::_ExamineArchiveFast(LPCTSTR ArcFileName,CConfigManager& ConfMan,bool &bInFolder,CString &BaseDir,CString &strErr)
{
	//sȃpXt@C͑SDLLΏĂĂƍl̂ŁASẴA[JCu͈SłƂ

	TRACE(_T("---_ExamineArchiveFast() called.\n"));
	ASSERT(IsOK());
	if(!IsOK()){
		return false;
	}

	if(!InspectArchiveBegin(ArcFileName,ConfMan)){
		strErr.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		return false;
	}

	bool bSureDir=false;	//BaseDirɓĂ镶񂪊mɃtH_łȂtrue
	bInFolder=true;
	TRACE(_T("========\n"));
	while(InspectArchiveNext()){
		CString Buffer;
		InspectArchiveGetFileName(Buffer);
		Buffer.Replace(_T('\\'),_T('/'));		//pX؂蕶̒u
		TRACE(_T("%s\n"),Buffer);

		/*
		Separator͊i[t@C̐擪ɂ܂܂ĂĂׂł̂ŁA
		i[t@C̐擪ɂ/ĂtH_Ɋi[ꂽԂƂ͌ȂȂB
		*/
		const int Length=Buffer.GetLength();
		int StartIndex=0;
		for(;StartIndex<Length;StartIndex++){
			//擪SeparatorƂ΂Ă
#if defined(_UNICODE)||defined(UNICODE)
			if(_T('/')!=Buffer[StartIndex])break;
#else
			if(_MBC_SINGLE==_mbsbtype((const unsigned char *)(LPCTSTR)Buffer,StartIndex)){
				if(_T('/')!=Buffer[StartIndex])break;
			}
			else{	//SpȂSeparatorł͂Ȃ
				break;
			}
#endif//defined(_UNICODE)||defined(UNICODE)
		}

		int FoundIndex=0;
		while(bInFolder){
			FoundIndex=Buffer.Find(_T('/'),StartIndex);
			if(-1==FoundIndex){	//'/'i[t@C̐擪ȊOɊ܂܂Ȃꍇ
				if(!BaseDir.IsEmpty()&&BaseDir==Buffer){
					bSureDir=true;	//BaseDirtH_łƊmFꂽ
					break;
				}
				else if(BaseDir.IsEmpty()){
					//tH_̌'/'tȂA[JCo
					//̂ŏɏoĂƂ́AtH_Ɖ肷
					BaseDir=Buffer;
					bSureDir=false;
					break;
				}
			//	else{	͌Â@
			//		bInFolder=false;
			//		break;
			//	}
			}
			CString Dir=Buffer.Mid(StartIndex,FoundIndex-StartIndex);	//SeparatoȓO܂ł̕(fBNgɑ)𔲂oĂ
			//܂łׂ̒DirEmptył͂ȂƂۏ؂Ă
			//܂A댯ł͂ȂƂĂ
			TRACE(_T("Base=%s,Dir=%s\n"),BaseDir,Dir);

			if(_T('.')==Dir){	//./΃fBNgwƂĂ͖
				StartIndex=FoundIndex+1;
				continue;
			}
			if(BaseDir.IsEmpty()){
				BaseDir=Dir;
				bSureDir=true;
			}
			else if(BaseDir!=Dir){
				bInFolder=false;
			}
			else bSureDir=true;	//BaseDirfBNgƊmFꂽ
			break;
		}
	}
	TRACE(_T("========\n"));

	InspectArchiveEnd();
	//tH_ɓĂ悤ł͂邪AfBNgƉ肳ꂽ̏ꍇ
	if(bInFolder&&!bSureDir)bInFolder=false;
	return true;
}

void CArchiverDLL::FreeDLL()
{
	ASSERT(NULL==m_hInspectArchive);
	ArchiveHandler				=NULL;
	ArchiverGetVersion			=NULL;
	ArchiverGetSubVersion		=NULL;
	ArchiverCheckArchive		=NULL;
	ArchiverGetFileCount		=NULL;
	ArchiverGetFileName			=NULL;
	ArchiverQueryFunctionList	=NULL;
	ArchiverOpenArchive			=NULL;
	ArchiverCloseArchive		=NULL;
	ArchiverFindFirst			=NULL;
	ArchiverFindNext			=NULL;
	ArchiverGetAttribute		=NULL;
	ArchiverGetOriginalSizeEx	=NULL;
	ArchiverGetCompressedSizeEx	=NULL;
	ArchiverGetWriteTime		=NULL;
	ArchiverGetWriteTimeEx		=NULL;
	ArchiverGetMethod			=NULL;

	if(m_hInstDLL){
		FreeLibrary(m_hInstDLL);
		m_hInstDLL=NULL;
	}
}

LOAD_RESULT CArchiverDLL::LoadDLL(CConfigManager&,CString &strErr)
{
	FreeDLL();

	if(NULL==(m_hInstDLL=LoadLibrary(m_strDllName))){
		strErr.Format(IDS_ERROR_DLL_LOAD,m_strDllName);
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_NOT_FOUND;
	}

	ArchiveHandler=(COMMON_ARCHIVER_HANDLER)GetProcAddress(m_hInstDLL,m_AstrPrefix);
	if(NULL==ArchiveHandler){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(m_AstrPrefix));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	CStringA FunctionName=m_AstrPrefix;
	FunctionName+="GetVersion";
	ArchiverGetVersion=(COMMON_ARCHIVER_GETVERSION)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetVersion){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	//Tuo[W̎擾łDLL͌Ă
	FunctionName=m_AstrPrefix;
	FunctionName+="GetSubVersion";
	ArchiverGetSubVersion=(COMMON_ARCHIVER_GETVERSION)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetSubVersion){
	//[hɎsĂG[Ƃ͂Ȃ
		TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
	}
	//-------------------------
	// DLLo[W̃`FbN
	//-------------------------
	if((ArchiverGetVersion()<m_nRequiredVersion)){
		//W[o[WႢ
		strErr.Format(IDS_ERROR_DLL_TOO_OLD,m_strDllName);
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_TOO_OLD;
	}else if((ArchiverGetVersion()==m_nRequiredVersion)&&(NULL!=ArchiverGetSubVersion)&&(ArchiverGetSubVersion()<m_nRequiredSubVersion)){
		//}Ci[o[WႢ
		strErr.Format(IDS_ERROR_DLL_TOO_OLD,(LPCTSTR)m_strDllName);
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_TOO_OLD;
	}

	FunctionName=m_AstrPrefix;
	FunctionName+="CheckArchive";
	ArchiverCheckArchive=(COMMON_ARCHIVER_CHECKARCHIVE)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverCheckArchive){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	//XacRett.dllAish32.dllT|[gĂȂ
	FunctionName=m_AstrPrefix;
	FunctionName+="GetFileCount";
	ArchiverGetFileCount=(COMMON_ARCHIVER_GETFILECOUNT)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileCount){
	//[hɎsĂG[Ƃ͂Ȃ
		TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
	}

	if(LOAD_DLL_MINIMUM==m_LoadLevel){
		TRACE(_T("Minimum Function Set Load\n"));
		return LOAD_RESULT_OK;
	}

	//------------
	// ǉ֐Q
	//------------
	FunctionName=m_AstrPrefix;
	FunctionName+="QueryFunctionList";
	ArchiverQueryFunctionList=(COMMON_ARCHIVER_QUERYFUNCTIONLIST)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverQueryFunctionList){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	FunctionName=m_AstrPrefix;
	FunctionName+="OpenArchive";
	if(!ArchiverQueryFunctionList(23)){//23:???OpenArchive
		strErr.Format(IDS_ERROR_UNAVAILABLE_API,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}
	ArchiverOpenArchive=(COMMON_ARCHIVER_OPENARCHIVE)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverOpenArchive){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	FunctionName=m_AstrPrefix;
	FunctionName+="CloseArchive";
	if(!ArchiverQueryFunctionList(24)){//24:???CloseArchive
		strErr.Format(IDS_ERROR_UNAVAILABLE_API,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}
	ArchiverCloseArchive=(COMMON_ARCHIVER_CLOSEARCHIVE)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverCloseArchive){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	//FindFirst
	FunctionName=m_AstrPrefix;
	FunctionName+="FindFirst";
	if(!ArchiverQueryFunctionList(25)){//25:???FindFirst
		strErr.Format(IDS_ERROR_UNAVAILABLE_API,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}
	ArchiverFindFirst=(COMMON_ARCHIVER_FINDFIRST)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverFindFirst){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	//FindNext
	FunctionName=m_AstrPrefix;
	FunctionName+="FindNext";
	if(!ArchiverQueryFunctionList(26)){//26:???FindNext
		strErr.Format(IDS_ERROR_UNAVAILABLE_API,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}
	ArchiverFindNext=(COMMON_ARCHIVER_FINDNEXT)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverFindNext){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	if(LOAD_DLL_SIMPLE_INSPECTION==m_LoadLevel){
		TRACE(_T("Simple Inspection Set Load\n"));
		return LOAD_RESULT_OK;
	}

	//t@C擾
	FunctionName=m_AstrPrefix;
	FunctionName+="GetFileName";
	if(!ArchiverQueryFunctionList(57)){//57:???GetFileName
		strErr.Format(IDS_ERROR_UNAVAILABLE_API,FunctionName);
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}
	ArchiverGetFileName=(COMMON_ARCHIVER_GETFILENAME)GetProcAddress(m_hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileName){
		strErr.Format(IDS_ERROR_DLL_FUNCTION_GET,m_strDllName,(LPCTSTR)CA2T(FunctionName));
		FreeDLL();
		TRACE(_T("%s\n"),(LPCTSTR)strErr);
		return LOAD_RESULT_INVALID;
	}

	//t@C擾
	FunctionName=m_AstrPrefix;
	FunctionName+="GetAttribute";
	//CAB32.DLLłCabGetAttribute()CabQueryFunctionList()ŗpsƕ񍐂邪
	//ۂ͗p\ł邽߁AΏǗÖ@Iɂ𖳌ɂB
/*	if(!ArchiverQueryFunctionList(64)){//64:???GetAttribute
		TRACE(_T("Function %s is not Available\n"),FunctionName);
	}
	else{*/
		ArchiverGetAttribute=(COMMON_ARCHIVER_GETATTRIBUTE)GetProcAddress(m_hInstDLL,FunctionName);
		if(NULL==ArchiverGetAttribute){
			TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
		}
//	}

	//t@CTCY擾(kO)
	FunctionName=m_AstrPrefix;
	FunctionName+="GetOriginalSizeEx";
	if(!ArchiverQueryFunctionList(85)){//85:???GetOriginalSizeEx
		TRACE(_T("Function %s is not Available\n"),(LPCTSTR)CA2T(FunctionName));
	}
	else{
		ArchiverGetOriginalSizeEx=(COMMON_ARCHIVER_GETORIGINALSIZEEX)GetProcAddress(m_hInstDLL,FunctionName);
		if(NULL==ArchiverGetOriginalSizeEx){
			TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
		}
	}

	//t@CTCY擾(k)
	FunctionName=m_AstrPrefix;
	FunctionName+="GetCompressedSizeEx";
	if(!ArchiverQueryFunctionList(86)){//86:???GetCompressedSizeEx
		TRACE(_T("Function %s is not Available\n"),(LPCTSTR)CA2T(FunctionName));
	}
	else{
		ArchiverGetCompressedSizeEx=(COMMON_ARCHIVER_GETORIGINALSIZEEX)GetProcAddress(m_hInstDLL,FunctionName);
		if(NULL==ArchiverGetCompressedSizeEx){
			TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
		}
	}

	//t@C擾(g)
	FunctionName=m_AstrPrefix;
	FunctionName+="GetWriteTimeEx";
	if(!ArchiverQueryFunctionList(70)){//70:???GetWriteTimeEx
		TRACE(_T("Function %s is not Available\n"),(LPCTSTR)CA2T(FunctionName));
	}
	else{
		ArchiverGetWriteTimeEx=(COMMON_ARCHIVER_GETWRITETIMEEX)GetProcAddress(m_hInstDLL,FunctionName);
		if(NULL==ArchiverGetWriteTimeEx){
			TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
		}
	}
	//t@C擾(ʏ;głgȂƂ̂)
	if(NULL==ArchiverGetWriteTimeEx){
		FunctionName=m_AstrPrefix;
		FunctionName+="GetWriteTime";
		if(!ArchiverQueryFunctionList(67)){//67:???GetWriteTime
			TRACE(_T("Function %s is not Available\n"),(LPCTSTR)CA2T(FunctionName));
		}
		else{
			ArchiverGetWriteTime=(COMMON_ARCHIVER_GETWRITETIME)GetProcAddress(m_hInstDLL,FunctionName);
			if(NULL==ArchiverGetWriteTime){
				TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
			}
		}
	}

	//t@Ck\bh擾
	FunctionName=m_AstrPrefix;
	FunctionName+="GetMethod";
	if(!ArchiverQueryFunctionList(66)){//66:???GetMethod
		TRACE(_T("Function %s is not Available\n"),(LPCTSTR)CA2T(FunctionName));
	}
	else{
		ArchiverGetMethod=(COMMON_ARCHIVER_GETMETHOD)GetProcAddress(m_hInstDLL,FunctionName);
		if(NULL==ArchiverGetMethod){
			TRACE(_T("Failed to Load Function %s\n"),(LPCTSTR)CA2T(FunctionName));
		}
	}


	if(LOAD_DLL_STANDARD==m_LoadLevel){
		TRACE(_T("Standard Function Set Load\n"));
		return LOAD_RESULT_OK;
	}

	ASSERT(!"Unknown Load Set!!!");
	return LOAD_RESULT_INVALID;
}

bool CArchiverDLL::InspectArchiveBegin(LPCTSTR ArcFileName,CConfigManager&)
{
	TRACE(_T("CArchiverDLL::InspectArchiveBegin()\n"));
	ASSERT(ArchiverOpenArchive);
	if(!ArchiverOpenArchive){
		return false;
	}
	if(m_hInspectArchive){
		ASSERT(!"Close the Archive First!!!\n");
		return false;
	}
	m_hInspectArchive=ArchiverOpenArchive(NULL,CT2A(ArcFileName),m_dwInspectMode);
	if(!m_hInspectArchive){
		TRACE(_T("Failed to Open Archive\n"));
		return false;
	}
	m_bInspectFirstTime=true;

	FILL_ZERO(m_IndividualInfo);
	return true;
}

bool CArchiverDLL::InspectArchiveEnd()
{
	ASSERT(ArchiverCloseArchive);
	if(!ArchiverCloseArchive){
		return false;
	}
	if(!m_hInspectArchive){
		ASSERT(!"The Archive is Already Closed!!!\n");
		return false;
	}
	ArchiverCloseArchive(m_hInspectArchive);
	m_hInspectArchive=NULL;
	return true;
}

bool CArchiverDLL::InspectArchiveGetFileName(CString &FileName)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	if(ArchiverGetFileName){
		char szBuffer[FNAME_MAX32*2+1]={0};
		ArchiverGetFileName(m_hInspectArchive,szBuffer,FNAME_MAX32*2);
		FileName=szBuffer;
		return true;
	}
	else{
		ASSERT(LOAD_DLL_STANDARD!=m_LoadLevel);
		FileName=m_IndividualInfo.szFileName;
		return true;
	}
}

bool CArchiverDLL::InspectArchiveNext()
{
	ASSERT(ArchiverFindFirst);
	ASSERT(ArchiverFindNext);
	if(!ArchiverFindFirst||!ArchiverFindNext){
		return false;
	}
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}

	FILL_ZERO(m_IndividualInfo);
	bool bRet;
	if(m_bInspectFirstTime){
		m_bInspectFirstTime=false;
		bRet=(0==ArchiverFindFirst(m_hInspectArchive,m_AstrFindParam,&m_IndividualInfo));
	}
	else{
		bRet=(0==ArchiverFindNext(m_hInspectArchive,&m_IndividualInfo));
	}

	return bRet;
}

int CArchiverDLL::InspectArchiveGetAttribute()
{
//	ASSERT(ArchiverGetAttribute);
	//ΉĂȂDLL(CAB32.dllȂ)łNULLɂȂĂ
	if(!ArchiverGetAttribute){
		return -1;
	}
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}

	return ArchiverGetAttribute(m_hInspectArchive);
}

bool CArchiverDLL::InspectArchiveGetOriginalFileSize(LARGE_INTEGER &FileSize)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	if(ArchiverGetOriginalSizeEx){
		return (FALSE!=ArchiverGetOriginalSizeEx(m_hInspectArchive,&FileSize));
	}
	else{
		//APIɂt@CTCY擾Ɏŝō\̂̃f[^𗘗p
		if(-1==m_IndividualInfo.dwOriginalSize)return false;
		FileSize.HighPart=0;
		FileSize.LowPart=m_IndividualInfo.dwOriginalSize;
		return true;
	}
}

bool CArchiverDLL::InspectArchiveGetCompressedFileSize(LARGE_INTEGER &FileSize)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	if(ArchiverGetCompressedSizeEx){
		return (FALSE!=ArchiverGetCompressedSizeEx(m_hInspectArchive,&FileSize));
	}
	else{
		//APIɂt@CTCY擾Ɏŝō\̂̃f[^𗘗p
		if(-1==m_IndividualInfo.dwCompressedSize)return false;
		FileSize.HighPart=0;
		FileSize.LowPart=m_IndividualInfo.dwCompressedSize;
		return true;
	}
}

bool CArchiverDLL::InspectArchiveGetWriteTime(FILETIME &FileTime)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	//gŊ֐Ŏ擾
	if(ArchiverGetWriteTimeEx){
		if(!ArchiverGetWriteTimeEx(m_hInspectArchive,&FileTime))return false;
		return true;
	}
	//ʏŊ֐Ŏ擾
	else if(ArchiverGetWriteTime){
		DWORD UnixTime=ArchiverGetWriteTime(m_hInspectArchive);
		if(-1==UnixTime){
			return false;
		}
		//time_tFileTime֕ϊ
		LONGLONG ll = Int32x32To64(UnixTime, 10000000) + 116444736000000000;
		FileTime.dwLowDateTime = (DWORD) ll;
		FileTime.dwHighDateTime = (DWORD)(ll >>32);
		return true;
	}
	else{
		//INDIVIDUALINFO玞擾
		FILETIME TempTime;
		if(!DosDateTimeToFileTime(m_IndividualInfo.wDate,m_IndividualInfo.wTime,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
}

//ɓt@CCRC擾
DWORD CArchiverDLL::InspectArchiveGetCRC()
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}
	return m_IndividualInfo.dwCRC;
}

//ɓt@Ck擾
WORD CArchiverDLL::InspectArchiveGetRatio()
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}

	return m_IndividualInfo.wRatio;
}

//ɓt@Ci[[h擾
//ANSI
bool CArchiverDLL::InspectArchiveGetMethodString(CString &strMethod)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}

	//\0ŏIĂ邩ǂۏ؂łȂ
	char szBuffer[32]={0};

	if(ArchiverGetMethod){
		if(0!=ArchiverGetMethod(m_hInspectArchive,szBuffer,31)){
			//\̂擾
			//strncpy(szBuffer,m_IndividualInfo.szMode,8);
			strncpy_s(szBuffer,m_IndividualInfo.szMode,8);
		}
	}
	else{
		//\̂擾
		//strncpy(szBuffer,m_IndividualInfo.szMode,8);
		strncpy_s(szBuffer,m_IndividualInfo.szMode,8);
	}

	//i[
	strMethod=szBuffer;
	return true;
}

ARCRESULT CArchiverDLL::TestArchive(LPCTSTR lpszFile,CString &strMsg)
{
	ASSERT(IsOK());
	if(!IsOK())return TEST_ERROR;
	TRACE(_T("TestArchive() called.\n"));
	//ftHgł̓eXg͎ĂȂ

	strMsg.Format(IDS_TESTARCHIVE_UNAVAILABLE,lpszFile,GetName());
	return TEST_NOTIMPL;
}


//X|Xt@CɃt@CGXP[vsŏށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverDLL::WriteResponceFile(HANDLE hFile,LPCTSTR fname,bool bQuoteSpaces)
{
	CPath path(fname);
	if(bQuoteSpaces){
		path.QuoteSpaces();
	}
	char szBuffer[_MAX_PATH+1]={0};

	strncpy_s(szBuffer,CT2A(path),_MAX_PATH);

	TRACE(_T("%s\n"),CA2T(szBuffer));

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,szBuffer,strlen(szBuffer)*sizeof(char),&dwWritten,NULL);

	//t@C؂邽߂̉s
	char CRLF[]="\r\n";
	WriteFile(hFile,&CRLF,strlen(CRLF)*sizeof(char),&dwWritten,NULL);
}

bool CArchiverDLL::ExtractItems(LPCTSTR lpszArcFile,CConfigManager &ConfMan,const ARCHIVE_ENTRY_INFO_TREE *lpBase, const std::list<ARCHIVE_ENTRY_INFO_TREE *> &items, LPCTSTR lpszOutputBaseDir, bool bCollapseDir, CString &strLog)
{
	//A[JCȗ݂͊ɊmFς݂Ƃ
	//R[h֌W͊ɊmFς݂Ƃ

	//---Xgt@CƃfBNg𕪗
	ARCHIVE_ENTRY_INFO_TREE *lpFileParent=NULL;	//t@C̐e
	std::list<CString> files;			//t@Cp
	std::list<ARCHIVE_ENTRY_INFO_TREE*> dirs;	//fBNgp

	std::list<ARCHIVE_ENTRY_INFO_TREE*>::const_iterator ite=items.begin();
	const std::list<ARCHIVE_ENTRY_INFO_TREE*>::const_iterator end=items.end();
	for(;ite!=end;++ite){
		ARCHIVE_ENTRY_INFO_TREE* lpNode=*ite;
		if(lpNode->bDir){
			dirs.push_back(lpNode);
		}else{
			lpFileParent=lpNode->lpParent;
			files.push_back(lpNode->strFullPath);
		}
	}

	// t@C
	if(!files.empty()){
		CString pathOutputDir;
		if(!bCollapseDir){
			ArcEntryInfoTree_GetNodePathRelative(lpFileParent,lpBase,pathOutputDir);
		}
		pathOutputDir=lpszOutputBaseDir+pathOutputDir;
		bool bRet=ExtractSpecifiedOnly(lpszArcFile,ConfMan,pathOutputDir,files,strLog);
		if(!bRet){
			return false;
		}
	}

	// fBNg
	if(!dirs.empty()){
		ExtractSubDirectories(lpszArcFile,ConfMan,lpBase,dirs,lpszOutputBaseDir,bCollapseDir,strLog);
		//std::list<CDirectoryTree*>::iterator ite=dirs.begin();
		//const std::list<CDirectoryTree*>::iterator end=dirs.end();
		//if(QueryFastExtractSpecifiedOnlySupported()){	//łgp\
		//	for(;ite!=end;ite++){
		//		if(!ExtractSubDirectoryFast(lpArchiver,ArcFileName,bCollapseDir?(*ite)->GetParent():Base,*ite,lpszOutputBaseDir,strLog))return false;
		//	}
		//}else{
		//	for(;ite!=end;ite++){
		//		if(!ExtractSubDirectory(lpArchiver,ArcFileName,bCollapseDir?(*ite)->GetParent():Base,*ite,lpszOutputBaseDir,strLog))return false;
		//	}
		//}
	}
	return true;
}

//w肳ꂽfBNgWJ;{
bool CArchiverDLL::ExtractSubDirectories(LPCTSTR lpszArcFile,CConfigManager &ConfMan,const ARCHIVE_ENTRY_INFO_TREE* lpBase,const std::list<ARCHIVE_ENTRY_INFO_TREE*> &dirs,LPCTSTR lpszOutputDir,bool bCollapseDir,CString &strLog)
{
	std::list<ARCHIVE_ENTRY_INFO_TREE*>::const_iterator ite=dirs.begin();
	const std::list<ARCHIVE_ENTRY_INFO_TREE*>::const_iterator end=dirs.end();
	for(;ite!=end;++ite){
		if(!ExtractDirectoryEntry(lpszArcFile,ConfMan,bCollapseDir?(*ite)->lpParent:lpBase,*ite,lpszOutputDir,bCollapseDir,strLog))return false;
	}
	return true;
}

//w肳ꂽfBNgWJ;{
bool CArchiverDLL::ExtractDirectoryEntry(LPCTSTR lpszArcFile,CConfigManager &ConfMan,const ARCHIVE_ENTRY_INFO_TREE* lpBase,const ARCHIVE_ENTRY_INFO_TREE* lpDir,LPCTSTR lpszOutputBaseDir,bool bCollapseDir,CString &strLog)
{
	//fBNg̃t@C
	std::list<CString> files;			//t@Cp
	std::list<ARCHIVE_ENTRY_INFO_TREE*> dirs;	//fBNgp

	//fBNgA[JCuɃGgƂēo^ĂĂ
	//->ʏʂo͂Əo͐ƌ邱Ƃ
	UINT nItems=lpDir->GetNumChildren();
	for(UINT i=0;i<nItems;i++){
		ARCHIVE_ENTRY_INFO_TREE* lpNode=lpDir->GetChild(i);

		if(lpNode->bDir){
			dirs.push_back(lpNode);
		}else{
			files.push_back(lpNode->strFullPath);
		}
	}

	//--------------------------------------
	// Cꂽo̓fBNgpXZo
	//--------------------------------------
	CString pathOutputDir;
	ArcEntryInfoTree_GetNodePathRelative(lpDir,lpBase,pathOutputDir);

	//o̓fBNgƌ
	pathOutputDir=lpszOutputBaseDir+pathOutputDir;

	if(pathOutputDir.GetLength()>_MAX_PATH){
		//tH_Ȃ肷
		strLog=CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH));
		return false;
	}

	if(files.empty() && dirs.empty() && lpDir->strFullPath.IsEmpty()){	//tH_A[JCuɑ݂ꍇ
		//fBNgGgƂŕ
		if(!UtilMakeSureDirectoryPathExists(pathOutputDir)){
			strLog.Format(IDS_ERROR_CANNOT_MAKE_DIR,(LPCTSTR)pathOutputDir);
			return false;
		}
		return true;
	}

	//---ċAIɏ

	//----------------
	// t@C
	//----------------
	if(!files.empty()){
		if(!ExtractSpecifiedOnly(lpszArcFile,ConfMan,pathOutputDir,files,strLog)){
			return false;
		}
	}

	//--------------------
	// fBNg
	//--------------------
	if(!dirs.empty()){
		ExtractSubDirectories(lpszArcFile,ConfMan,bCollapseDir?lpDir:lpBase,dirs,lpszOutputBaseDir,bCollapseDir,strLog);
	}
	return true;
}
