#pragma once
#include "FileListModel.h"
#include "FileListView.h"
#include "FileTreeView.h"
#include "../Utilities/TemporaryDirMgr.h"

struct CConfigFileListWindow;
struct CFileListTabItem{
	DISALLOW_COPY_AND_ASSIGN(CFileListTabItem);
public:
	DLL_ID idForceDLL;	//gpDLL
	CFileListModel	Model;

	CSplitterWindow	Splitter;	// Xvb^EBhE
	CFileListView	ListView;
	CFileTreeView	TreeView;	// tH_̃c[r[

	HWND			m_hFrameWnd;

	//dopenj~p
	HANDLE hMutex;	//NULLȊOȂAIɕ
	CString strMutexName;
protected:
	//---internal functions
	bool CreateListView(HWND hParentWnd,HWND hFrameWnd,const CConfigFileListWindow&);
	bool CreateTreeView(HWND hParentWnd,HWND hFrameWnd,const CConfigFileListWindow&);
public:
	CFileListTabItem(CConfigManager &rMan);
	virtual ~CFileListTabItem(){DestroyWindow();}
	bool CreateTabItem(HWND hParentWnd,HWND hFrameWnd,const CConfigFileListWindow&);
	HRESULT OpenArchive(LPCTSTR lpszArc,DLL_ID forceID,const CConfigFileListWindow& ConfFLW,FILELISTMODE flMode,IArchiveContentUpdateHandler* lpHandler,CString &strErr);

	void DestroyWindow();
	void ShowWindow(int nCmdShow);
	void OnActivated();
	void OnDeactivated();

	int GetTreeWidth(){return Splitter.GetSplitterPos();}
	void SetTreeWidth(int width){Splitter.SetSplitterPos(width);}

	DWORD GetListViewStyle();
	void SetListViewStyle(DWORD);
};
