#include "stdafx.h"
#include "shellmanager.h"
#include "../Utilities/Utility.h"
#include "../Utilities/OSUtil.h"
#include "../resource.h"


const int CLSID_STRING_SIZE=(39 + 1);

//---IA32
//ENbNj[nh
// {713B479F-6F2B-48e9-B545-5591CCFE398F}
static const GUID CLSID_ShellExtShellMenu32 = 
{ 0x713b479f, 0x6f2b, 0x48e9, { 0xb5, 0x45, 0x55, 0x91, 0xcc, 0xfe, 0x39, 0x8f } };

//EhbOj[nh
// {5E5B692B-D6ED-4103-A1FA-9A71A93DAC88}
static const GUID CLSID_ShellExtDragMenu32 = 
{ 0x5e5b692b, 0xd6ed, 0x4103, { 0xa1, 0xfa, 0x9a, 0x71, 0xa9, 0x3d, 0xac, 0x88 } };

//---AMD64
//ENbNj[nh
// {B7584D74-DE0C-4db5-80DD-42EEEDF42665}
static const GUID CLSID_ShellExtShellMenu64 = 
{ 0xb7584d74, 0xde0c, 0x4db5, { 0x80, 0xdd, 0x42, 0xee, 0xed, 0xf4, 0x26, 0x65 } };

//EhbOj[nh
// {00521ADB-148D-45c9-8021-7446EE35609D}
static const GUID CLSID_ShellExtDragMenu64 = 
{ 0x521adb, 0x148d, 0x45c9, { 0x80, 0x21, 0x74, 0x46, 0xee, 0x35, 0x60, 0x9d } };


//-------------------------------------------------------------------------
// ShellRegisterServer			gVFo^
//-------------------------------------------------------------------------
bool ShellRegisterServer(HWND hWnd,LPCTSTR inDllPath)
{
	// Cu[h
	HINSTANCE theDllH = ::LoadLibrary(inDllPath);
	if(!theDllH){
		// [ho܂ł
		CString msg;
		msg.Format(IDS_ERROR_DLL_LOAD,inDllPath);
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		return false;
	}

	// Gg[|CgTĎs
	FARPROC lpDllEntryPoint;
	(FARPROC&)lpDllEntryPoint = ::GetProcAddress(theDllH,"DllRegisterServer");
	if(lpDllEntryPoint){
		// o^
		(*lpDllEntryPoint)();
//		MessageBeep(MB_OK);
	}else{
		// DllRegisterServer ܂
		CString msg;
		msg.Format(IDS_ERROR_DLL_FUNCTION_GET,inDllPath,_T("DllRegisterServer"));
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		::FreeLibrary(theDllH);
		return false;
	}
	::FreeLibrary(theDllH);
	return true;
}

//-------------------------------------------------------------------------
// ShellUnregisterServer			gVF
//-------------------------------------------------------------------------
bool ShellUnregisterServer(HWND hWnd,LPCTSTR inDllPath)
{
	// Cu[h
	HINSTANCE theDllH = ::LoadLibrary(inDllPath);
	if(!theDllH){
		// ۰ޏo܂ł
		CString msg;
		msg.Format(IDS_ERROR_DLL_LOAD,inDllPath);
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		return false;
	}

	// Gg[|CgTĎs
	FARPROC	lpDllEntryPoint;
	(FARPROC&)lpDllEntryPoint = ::GetProcAddress(theDllH,"DllUnregisterServer");
	if(lpDllEntryPoint){
		// o^
		(*lpDllEntryPoint)();
//		MessageBeep(MB_OK);
	}else{
		// DllUnregisterServer ܂
		CString msg;
		msg.Format(IDS_ERROR_DLL_FUNCTION_GET,inDllPath,_T("DllUnregisterServer"));
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		::FreeLibrary(theDllH);
		return false;
	}
	::FreeLibrary(theDllH);
	return true;
}


/*-------------------------------------------------------------------------*/
// CLSIDtoSTRING			NXID𕶎ɕϊ
/*-------------------------------------------------------------------------*/
void CLSIDtoSTRING(REFCLSID inClsid,CString &outCLSID)
{
	WCHAR theCLSID[CLSID_STRING_SIZE];

	// NXID𕶎ɕϊB
	StringFromGUID2(inClsid, theCLSID,CLSID_STRING_SIZE);
	outCLSID=theCLSID;
}

//-------------------------------------------------------------------------
// ShellRegistCheck		gShellݓo^Ă邩`FbN
//-------------------------------------------------------------------------
bool _ShellRegistCheck(const GUID inGUID)
{
	bool Result=false;
	// NXIDAWXgL[쐬
	CString theCLSID;
	CLSIDtoSTRING(inGUID, theCLSID);

	// L[쐬
	CString theKey=_T("CLSID\\")+theCLSID;

	// WXgɃL[邩ǂT

	// wL[̃I[v
	HKEY theKeyChildH;
	int flag=KEY_READ;
	if(UtilIsWow64())flag|=KEY_WOW64_64KEY;
	LONG theRes=::RegOpenKeyEx(HKEY_CLASSES_ROOT, theKey, 0, flag, &theKeyChildH);
	//wL[̃I[v
	if(theRes != ERROR_SUCCESS){
		return Result;
	}

	//wL[ɕ֘AÂĂΑ`FbN˔j
	DWORD dwLength=0;
	::RegQueryValueEx(theKeyChildH, NULL, NULL, NULL, NULL,&dwLength);
	if(dwLength>1){
		//`FbN
		// qGg̗
		TCHAR		theBuffer[256];
		DWORD		theSize = 256;
		FILETIME	theTime;
		DWORD		theIdx = 0;
		while(S_OK==::RegEnumKeyEx(theKeyChildH, theIdx, theBuffer, &theSize, NULL, NULL, NULL, &theTime)){
			if(_tcsicmp(theBuffer,_T("InprocServer32")) == 0){
				// rSI
				Result = true;
				break;
			}
			theSize = 256;
			theIdx++;
		}
	}

	// Close the child.
	::RegCloseKey(theKeyChildH);

	return Result;
}


bool ShellRegistCheck()
{
	return (_ShellRegistCheck(CLSID_ShellExtShellMenu32) || _ShellRegistCheck(CLSID_ShellExtShellMenu64));
}
